﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms.Design;
using System.Windows.Forms;
using System.Collections;

namespace DxDesigner.Components
{
    class DxTextComponentDesigner: ControlDesigner
    {
        string[] validKeys = new string[] { "text", "Location", "Size", "Font", "ForeColor", "Column", "Format", "Index", "fileName", "DTFormat"};

        protected override void PreFilterProperties(System.Collections.IDictionary properties)
        {
            base.PreFilterProperties(properties);
 
            List<string> propList = new List<string>();
            foreach (DictionaryEntry de in properties)
                propList.Add(de.Key.ToString());

            for (int i = 0; i < propList.Count; i++ )
            {
                string propname = propList[i];
                bool found = false;
                foreach (string validKey in validKeys)
                {
                    if (validKey == propname)
                    {
                        found = true;
                        break;
                    }
                }
                if (!found)
                    properties.Remove(propname);
            }

        }
    }

    class DxContainerDesigner : ControlDesigner
    {
        string[] validKeys = new string[] {"Size", "Rotate", "SWL" };

        protected override void PreFilterProperties(System.Collections.IDictionary properties)
        {
            base.PreFilterProperties(properties);

            List<string> propList = new List<string>();
            foreach (DictionaryEntry de in properties)
                propList.Add(de.Key.ToString());

            for (int i = 0; i < propList.Count; i++)
            {
                string propname = propList[i];
                bool found = false;
                foreach (string validKey in validKeys)
                {
                    if (validKey == propname)
                    {
                        found = true;
                        break;
                    }
                }
                if (!found)
                    properties.Remove(propname);
            }

        }
    }
}
