﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace DxDesigner.Components
{
    [Designer(typeof(DxTextComponentDesigner))]
    public partial class DxFrame : UserControl
    {
        
        public DxFrame()
        {
            InitializeComponent();
            SetStyle(ControlStyles.SupportsTransparentBackColor, true);

            XmlDocument doc = new XmlDocument();
            DxSerialize(doc);
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            e.Graphics.DrawRectangle(Pens.Black, 0, 0, Size.Width-1, Size.Height-1);
        }

        public XmlNode DxSerialize(XmlDocument parent)
        {
            XmlNode comp = parent.CreateElement("frame");
            try
            {
                XmlNode param = parent.CreateElement("x");
                XmlNode val = parent.CreateTextNode((this.Location.X / MainForm.sizeconst).ToString());
                param.AppendChild(val);
                comp.AppendChild(param);

                param = parent.CreateElement("y");
                val = parent.CreateTextNode((this.Location.Y / MainForm.sizeconst).ToString());
                param.AppendChild(val);
                comp.AppendChild(param);

                param = parent.CreateElement("width");
                val = parent.CreateTextNode((this.Width / MainForm.sizeconst).ToString());
                param.AppendChild(val);
                comp.AppendChild(param);

                param = parent.CreateElement("height");
                val = parent.CreateTextNode((this.Height / MainForm.sizeconst).ToString());
                param.AppendChild(val);
                comp.AppendChild(param);

                if (this.ForeColor.ToKnownColor() != System.Drawing.KnownColor.ControlText)
                {
                    param = parent.CreateElement("color");
                    val = parent.CreateTextNode(this.ForeColor.Name);
                    param.AppendChild(val);
                    comp.AppendChild(param);
                }
            }
            catch
            {
            }

            return comp;
        }

        public void DxDeserialize(XmlNode node)
        {
            while (node != null)
            {
                switch (node.Name)
                {
                    case "x":
                        Left = (int)(MainForm.sizeconst * float.Parse(node.FirstChild.Value));
                        break;
                    case "y":
                        Top = (int)(MainForm.sizeconst * float.Parse(node.FirstChild.Value));
                        break;
                    case "width":
                        Width = (int)(MainForm.sizeconst * float.Parse(node.FirstChild.Value));
                        break;
                    case "height":
                        Height = (int)(MainForm.sizeconst * float.Parse(node.FirstChild.Value));
                        break;
                    case "color":
                        this.ForeColor = Color.FromName(node.FirstChild.Value);
                        break;
                }
                node = node.NextSibling;
            }
        }
    }
}
