﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace DxDesigner.Components
{
    [Designer(typeof(DxTextComponentDesigner))]
    public partial class DxPicture : UserControl
    {
        public DxPicture()
        {
            InitializeComponent();
            fileName = "";
        }

        string filename = "";
        [Category("DxPicture")]
        public string fileName
        {
            set
            {
                int pos = MainForm.fileName.LastIndexOf("\\");
                string path = "";
                if (pos > 0)
                    path = MainForm.fileName.Substring(0, pos) + "\\";
                filename = value;
                Image image;
                try
                {
                    image = Image.FromFile(path + filename);
                }
                catch
                {
                    try
                    {
                        image = Image.FromFile(filename);
                    }
                    catch
                    {
                        image = DxDesigner.Properties.Resources.sampleImage;
                    }
                }
                pictureBox1.Image = image;
                pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            get
            {
                return filename;
            }

        }

        public XmlNode DxSerialize(XmlDocument parent)
        {
            XmlNode comp = parent.CreateElement("picture");
            try
            {
                XmlNode param = parent.CreateElement("x");
                XmlNode val = parent.CreateTextNode((this.Location.X / MainForm.sizeconst).ToString());
                param.AppendChild(val);
                comp.AppendChild(param);

                param = parent.CreateElement("y");
                val = parent.CreateTextNode((this.Location.Y / MainForm.sizeconst).ToString());
                param.AppendChild(val);
                comp.AppendChild(param);

                param = parent.CreateElement("width");
                val = parent.CreateTextNode((this.Width / MainForm.sizeconst).ToString());
                param.AppendChild(val);
                comp.AppendChild(param);

                param = parent.CreateElement("height");
                val = parent.CreateTextNode((this.Height / MainForm.sizeconst).ToString());
                param.AppendChild(val);
                comp.AppendChild(param);

                param = parent.CreateElement("filename");
                val = parent.CreateTextNode(this.filename);
                param.AppendChild(val);
                comp.AppendChild(param);
            }
            catch
            {
            }

            return comp;
        }

        public void DxDeserialize(XmlNode node)
        {
            while (node != null)
            {
                switch (node.Name)
                {
                    case "x":
                        Left = (int)(MainForm.sizeconst * float.Parse(node.FirstChild.Value));
                        break;
                    case "y":
                        Top = (int)(MainForm.sizeconst * float.Parse(node.FirstChild.Value));
                        break;
                    case "width":
                        Width = (int)(MainForm.sizeconst * float.Parse(node.FirstChild.Value));
                        break;
                    case "height":
                        Height = (int)(MainForm.sizeconst * float.Parse(node.FirstChild.Value));
                        break;
                    case "filename":
                        fileName = node.FirstChild == null? "":node.FirstChild.Value;
                        break;
                }
                node = node.NextSibling;
            }
        }
    }
}
