﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel.Design.Serialization;

namespace DxDesigner
{
    internal class DxNameCreationService : INameCreationService
    {

        public string CreateName(System.ComponentModel.IContainer container, System.Type dataType)
        {
            if ((container == null) || (dataType == null))
                return "????";

            int i = 0;
            string name = dataType.Name;

            // Find the name which is not used
            while (true)
            {
                i++;
                if (container.Components[name + i.ToString()] == null)
                    break;
            }

            return name + i.ToString();
        }

        public bool IsValidName(string name)
        {
            if (name == null || name.Length == 0)
                return false;

            if (!Char.IsLetter(name, 0))
                return false;

            if (name.StartsWith("_"))
                return false;

            for (int i = 0; i < name.Length; i++)
            {
                if (!Char.IsLetterOrDigit(name, i))
                    return false;
            }

            return true;
        }

        public void ValidateName(string name)
        {
            if (!IsValidName(name))
                throw new ArgumentException("Invalid name: " + name);
        }

    }
}
