using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel.Design;
using System.Windows.Forms;
using System.ComponentModel.Design.Serialization;
using System.Diagnostics;
using System.Collections;

namespace DxDesigner.Host
{
    public class DxDesignSurface : DesignSurface
    {
        ISelectionService _selectionService = null;
        BasicDesignerLoader designLoader;

        public void Initialize()
        {
			IDesignerHost host = (IDesignerHost)this.GetService(typeof(IDesignerHost));
            //service jiz drive implementovany, asi zakladni service pro designer


 //           this.AddService(typeof(IMenuCommandService), new xhmiMenuCommandService(host, this));
            ServiceContainer.AddService(typeof(DxSelectionService), new DxSelectionService(host));
            ServiceContainer.AddService(typeof(IDesignerSerializationService), new DxSerializationService(host));
            CodeDomComponentSerializationService serSvc = new CodeDomComponentSerializationService(this.ServiceContainer);
            ServiceContainer.AddService(typeof(ComponentSerializationService), serSvc);


            IMenuCommandService mcs = (IMenuCommandService)this.GetService(typeof(IMenuCommandService));
            // mcs.AddCommand(undoCommand);

// toto nemaka, protoze default funkce MenucommandService::ShowContextMenu je prazdna
//           mcs.AddVerb(new DesignerVerb("Copy", new EventHandler(menuItem_Click), StandardCommands.Copy));
//           mcs.AddVerb(new DesignerVerb("Delete", new EventHandler(menuItem_Click), StandardCommands.Delete));

            //xhmiDesignerOptionService designerOptionService = new xhmiDesignerOptionService(null);
            //this.AddService(typeof(IDesignerOptionService), designerOptionService);
			if (host == null)
				return;

			try
			{
				// Set the backcolor
				Type hostType = host.RootComponent.GetType();

				// Set SelectionService - SelectionChanged event handler
				_selectionService = (ISelectionService)(this.ServiceContainer.GetService(typeof(ISelectionService)));

                _selectionService.SelectionChanged += new EventHandler(SelChanged);

			}
            catch (Exception ex)
            {
                Trace.WriteLine(ex.ToString());
            }
        }

        public void SelChanged(object ox, EventArgs arg)
        {
            if (_selectionService != null)
            {
                ICollection selectedComponents = _selectionService.GetSelectedComponents();
                PropertyGrid propertyGrid = (PropertyGrid)this.GetService(typeof(PropertyGrid));


                object[] comps = new object[selectedComponents.Count];
                int i = 0;

                foreach (Object o in selectedComponents)
                {
                    comps[i] = o;
                    i++;
                }

                propertyGrid.SelectedObjects = comps;
            }
        }

        public DxDesignSurface(IServiceProvider parentProvider) : base(parentProvider)
		{
            ServiceContainer.AddService(typeof(IMenuCommandService),  new MenuCommandService(this));
        }

        public BasicDesignerLoader Loader
        {
            get
            {
                return designLoader;
            }
            set
            {
                designLoader = value;
            }
        }
    }
}
