using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.ComponentModel.Design.Serialization;


namespace DxDesigner.Host
{
    public class DxDesignSurfaceManager : DesignSurfaceManager
    {

        public DxDesignSurfaceManager()
            : base()
		{
			this.AddService(typeof(INameCreationService), new DxNameCreationService());
		}

        protected override DesignSurface CreateDesignSurfaceCore(IServiceProvider parentProvider)
        {
            return new DxDesignSurface(parentProvider);
        }

        public void AddService(Type type, object serviceInstance)
        {
            // ServiceContainer is protected member
            ServiceContainer.AddService(type, serviceInstance);
        }

        public DxHostControl GetNewHost()
        {

            DxDesignSurface designSurface = (DxDesignSurface)CreateDesignSurface(ServiceContainer);
            IDesignerHost host = (IDesignerHost)designSurface.GetService(typeof(IDesignerHost));


            Host.DxDesignerLoader basicHostLoader = new Host.DxDesignerLoader();
            designSurface.BeginLoad(basicHostLoader);
            designSurface.Loader = basicHostLoader;
            designSurface.Initialize();
            return new DxHostControl(designSurface);
        }
    }
}
