using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.ComponentModel.Design;

namespace DxDesigner.Host
{
    public partial class DxHostControl : UserControl
    {

        public DxHostControl(DxDesignSurface designSurface)
        {
            InitializeComponent();
            InitializeHost(designSurface);
        }

        // get this instance of DesignSurface
        public DxDesignSurface DesignSurface
        {
            get
            {
                return designSurface;
            }
        }
        public IDesignerHost DesignerHost
        {
            // to get interface to IDesignerHost of this instance of DesignSurface
            get
            {
                return (IDesignerHost)designSurface.GetService(typeof(IDesignerHost));
            }
        }

        internal void InitializeHost(Host.DxDesignSurface dSurface)
        {
            try
            {
                if (dSurface == null)
                    return;

                designSurface = dSurface;   // save it for future use
                Control control = designSurface.View as Control;    // View Control of design surface is the only child component of DxHostControl
                control.Parent = this;
                control.Dock = DockStyle.Fill;  // it fills the whole DxHostControl
                control.Visible = true;
            }
            catch
            {
            }
        }

   }
}
