﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Xml;
using System.Data;
using System.Drawing;

namespace DxQsl
{
    class DxDateTime:DxBase
    {
        Font font;
        float size = 10.0f;
        FontStyle style = FontStyle.Regular;
        int index = 1;
        string text;
        string column = "Date";
        string dtformat;

        public DxDateTime(XmlNode node, DataTable qsos)
        {
            dtformat = "dd MMM yyyy HH:mm";
            string family = "Arial";   // default
            XmlNode param = node.FirstChild;
            while (param != null)
            {
                switch (param.Name)
                {
                    case "x":
                        x = (float)double.Parse(param.InnerText);
                        break;
                    case "y":
                        y = (float)double.Parse(param.InnerText);
                        break;
                    case "color":
                        color = Color.FromName(param.InnerText);
                        break;
                    case "font":
                        family = param.InnerText;
                        break;
                    case "size":
                        size = (float)double.Parse(param.InnerText);
                        break;
                    case "style":
                        if (param.InnerText.IndexOf("Bold") >= 0)
                            style |= FontStyle.Bold;
                        if (param.InnerText.IndexOf("Italic") >= 0)
                            style |= FontStyle.Italic;
                        if (param.InnerText.IndexOf("Underline") >= 0)
                            style |= FontStyle.Underline;
                        break;
                    case "index":
                        index = int.Parse(param.InnerText);
                        break;
                    case "column":
                        column = param.InnerText;
                        break;
                    case "DTFormat":
                        dtformat = param.InnerText;
                        break;
                }
                param = param.NextSibling;
            }
            font = new Font(family, size, style);

            try
            {
                DateTime dt = (DateTime)qsos.Rows[index-1][column];
                text = dt.ToString(dtformat);
            }
            catch
            {
                text = "---";
            }
        }

        public override void Print(Graphics g, float xoffset, float yoffset)
        {
            if (text != null)
                g.DrawString(text, font, new SolidBrush(color), new PointF((x + xoffset + DxQslDlg.xshift) * DxQslDlg.cc, (y + yoffset + DxQslDlg.yshift) * DxQslDlg.cc));
        }

        
    }
}
