﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Drawing;
using System.Xml;
using System.Data;

namespace DxQsl
{
    class DxFrame:DxBase
    {
        private float height = 10;
        private float width = 20;
        private float thickness = 1.0f;

        public DxFrame(XmlNode node)
        {
            XmlNode param = node.FirstChild;
            while (param != null)
            {
                switch (param.Name)
                {
                    case "x":
                        x = (float)double.Parse(param.InnerText);
                        break;
                    case "y":
                        y = (float)double.Parse(param.InnerText);
                        break;
                    case "color":
                        color = Color.FromName(param.InnerText);
                        break;
                    case "width":
                        width = (float)double.Parse(param.InnerText);
                        break;
                    case "height":
                        height = (float)double.Parse(param.InnerText);
                        break;
                    case "thickness":
                        thickness = (float)double.Parse(param.InnerText);
                        break;
                }
                param = param.NextSibling;
            }
        }

        public override void Print(Graphics g, float xoffset, float yoffset)
        {
            g.DrawRectangle(new Pen(color,thickness), (x + xoffset + DxQslDlg.xshift) * DxQslDlg.cc, (y + yoffset + DxQslDlg.yshift) * DxQslDlg.cc, width * DxQslDlg.cc, height * DxQslDlg.cc);
        }
    }
}
