﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Drawing;
using System.Xml;

namespace DxQsl
{
    class DxLabel:DxBase
    {
        string text;
        Font font;
        float size = 10.0f;
        FontStyle style = FontStyle.Regular;

        public DxLabel(XmlNode node)
        {
            string family = "Arial";
            XmlNode param = node.FirstChild;
            while (param != null)
            {
                switch (param.Name)
                {
                    case "text":
                        text = param.InnerText;
                        break;
                    case "x":
                        x = (float)double.Parse(param.InnerText);
                        break;
                    case "y":
                        y = (float)double.Parse(param.InnerText);
                        break;
                    case "color":
                        color = Color.FromName(param.InnerText);
                        break;
                    case "font":
                        family = param.InnerText;
                        break;
                    case "size":
                        size = (float)double.Parse(param.InnerText);
                        break;
                    case "style":
                        if (param.InnerText.IndexOf("Bold") >= 0)
                                style |= FontStyle.Bold;
                        if (param.InnerText.IndexOf("Italic") >= 0)
                                style |= FontStyle.Italic;
                        if (param.InnerText.IndexOf("Underline") >= 0)
                            style |= FontStyle.Underline;
                        break;
                }
                param = param.NextSibling;
            }
            font = new Font(family, size, style);
        }

        public override void Print(Graphics g, float xoffset, float yoffset)
        {
            g.DrawString(text, font, new SolidBrush(color), new PointF((x + xoffset + DxQslDlg.xshift) * DxQslDlg.cc, (y + yoffset + DxQslDlg.yshift) * DxQslDlg.cc));
        }
    }
}
