﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Xml;
using System.Data;
using System.Drawing;

namespace DxQsl
{
    class DxPicture: DxBase
    {
        string filename = null;
        float width = 10.0f;
        float height = 10.0f;
        string path;

        public DxPicture(XmlNode node, string path)
        {
            this.path = path;
            XmlNode param = node.FirstChild;
            while (param != null)
            {
                switch (param.Name)
                {
                    case "x":
                        x = (float)double.Parse(param.InnerText);
                        break;
                    case "y":
                        y = (float)double.Parse(param.InnerText);
                        break;
                    case "filename":
                        filename = param.InnerText;
                        break;
                    case "width":
                        width = (float)double.Parse(param.InnerText);
                        break;
                    case "height":
                        height = (float)double.Parse(param.InnerText);
                        break;
                }
                param = param.NextSibling;
            }
        }

        public override void Print(Graphics g, float xoffset, float yoffset)
        {
            if (filename != null)
            {
                try
                {
                    Image im;
                    try
                    {
                        im = Image.FromFile(path+filename);  // try template path first
                    }
                    catch
                    {
                        im = Image.FromFile(filename);   // if failed try absolute
                    }
                    g.DrawImage(im, (x + xoffset + DxQslDlg.xshift) * DxQslDlg.cc, (y + yoffset + DxQslDlg.yshift) * DxQslDlg.cc, width * DxQslDlg.cc, height * DxQslDlg.cc);
                }
                catch { }
            }
        }
    }
}
